#!/usr/bin/perl
use constant PORTACT=>815;
use constant PORTGET=>316;
use constant JURY=>'10.254.0.1';
my($act,$ip,$id,$flag)=@ARGV;

my $debug=1;

sub one{my $i=shift;print $i if($i);exit(1);}
sub two{my $i=shift;print $i if($i);exit(2);}
sub three{my $i=shift;print $i if($i);exit(3);}
sub four{my $i=shift;print $i if($i);exit(4);}
sub ten{my $i=shift;print $i if($i);exit(10);}

sub toip
{
	return '10.'.(shift).'.0.3';
}

sub HTTPRequest
{
	my($meth,$url)=@_;
	use LWP::UserAgent;
	my $ua=LWP::UserAgent->new;
	$ua->agent("ElephantChecker/0.1");
	$ua->timeout(5);
	my $req=HTTP::Request->new($meth=>$url);
	my $res=$ua->request($req);
	print STDERR "Debug: HTTP: ".$res->status_line."\n" if($debug);
	my ($code)=($res->status_line=~/(\d+)\s+/);
	return ($res->is_success,$res->content,$code);
}

sub SocketConnect
{
	my ($ip,$port)=@_;
	use Socket;
	my $proto=getprotobyname('tcp');
	socket(Socket_Handle,PF_INET,SOCK_STREAM,$proto);
	my $iaddr=gethostbyname($ip);
	my $sin=sockaddr_in($port,$iaddr);
	return (connect(Socket_Handle,$sin),Socket_Handle);
}

sub init
{
#	my($state,$resp)=HTTPRequest("GET","http://".JURY."/teams");
	my @teams;
#	if($state)
#	{
#		@teams=split(/\n/,$resp);
#	}else{
#		ten("No Jury machine found");
#	}
	my %h;
	my $i=1;
	while(-e "slonik_clients/clients$i.txt")
	{
		open FF,"slonik_clients/clients$i.txt";
		my @names=<FF>;
		for(@names)
		{
			s/^\s+|\s+$//g;
		}
		close FF;
#		print STDERR "Debug: for ".toip($i)." created ".scalar(@names)." names\n" if($debug);
		$h{toip($i)}=\@names;
		$i++;
	}
	return %h;
}

my %names=init();

if(!$ip)
{
	ten("No IP defined");
}

sub sendReq
{
	my ($h,$d)=@_;
	my $rout='';
	vec($rout,fileno($h),1)=1;
	if(select(undef,$rout,undef,2.0))
	{
		return send($h,$d,0);
	}
	print STDERR "Debug:No select in send\n" if($debug);
	return undef;
}

sub recvTry
{
	my $h=shift;
	my $rin='';
	vec($rin,fileno($h),1)=1;
	if(select($rin,undef,undef,2.0))
	{
		my $d='';
		if(defined recv($h,$d,8196,0))
		{
			return $d;
		}
		print STDERR "Debug:No receive\n" if($debug);
	}
	print STDERR "Debug:No select in receive\n" if($debug);
	return undef;
}

sub longWait
{
	my $h=shift;
	my $d=recvTry($h);
	my $n=10;
	while(!$d && $n)
	{
		$d=recvTry($h);
		$n--;
		print STDERR "Debug: Retry\n" if($debug);
	}
	return $d;
}

sub compare
{
	my($r1,$r2)=@_;
	$r1=unpack("H*",$r1);
	$r2=unpack("H*",$r2);
	my @r1;
	my @r2;
	while($r1=~s/(..)//)
	{
		push @r1,$1;
	}
	while($r2=~s/(..)//)
	{
		push @r2,$1;
	}
	my $i;
	my $ok=1;
	if(@r1 != @r2)
	{
		print STDERR "Debug: Sizes differ: ".scalar(@r1).'!='.scalar(@r2)."\n" if($debug);
		$ok=0;
	}
	my @b=();
	for($i=0;$i<@r1;$i++)
	{
		if($r1[$i] ne $r2[$i])
		{
			push @b,{add=>$i,r1=>$r1[$i],r2=>$r2[$i]};
			$ok=0;
		}
	}
	my $str='';
	for(@b)
	{
		$str.=$_->{add}.':'.$_->{r1}.'!'.$_->{r2}.',';
	}
	print STDERR "Debug: bad bytes at ".$str."\n" if($debug && @b);
	return $ok;
}

if($act eq 'put')
{
	if(!$flag)
	{
		ten("No Flag defined");
	}
	use Socket;
	my ($state,$handle)=SocketConnect($ip,PORTACT);
	if($state)
	{
		my $d='';
		if(!defined sendReq($handle,'')){ten("Can't start send");}
		$d=longWait($handle);
		if(!$d){three("No Elephant came");}
		if(!defined sendReq($handle,"I want to place banner\r\n")){ten("Can't send");}
		$d=recvTry($handle);
		if(!$d){three("No Dialog succeded");}
		print STDERR "Debug:".$d."\n" if($debug);
		my $r=`./flag2swf $flag`;
		$r=~s/^\s+|\s+$//g;
		my $res=undef;
		my $count=0;
		if(!length($r)){ten("System call to SWF transformer failed");}
		{
			open FF,"$r" or ten("Flash was not generated");
			binmode FF;
			$count=read(FF,$res,1024*1024*20);
			close FF;
		}
		if(!unlink $r)
		{
			if($debug){print STDERR "Debug: $r not unlinked $?:$!\n";}
		}else{
			if($debug){print STDERR "Debug: $r unlinked\n";}
		}
		my $selname=$names{$ip}->[int(rand(@{$names{$ip}}))];
		print STDERR "Debug: ".$selname." with length ".$count."\n" if($debug);
		if(!defined sendReq($handle,$selname."\r\n")){ten("Can't send");}
		$d=recvTry($handle);
		if(!$d){three("No Dialog succeded");}
		print STDERR "Debug:".$d."\n" if($debug);
		if(!defined sendReq($handle,$count."\r\n")){ten("Can't send");}
		$d=recvTry($handle);
		if(!$d){three("No Dialog succeded");}
		print STDERR "Debug:".$d."\n" if($debug);
		if(!defined sendReq($handle,$res)){ten("Can't send");}
		my $d=recvTry($handle);
		if(!$d){three("No Dialog succeded");}
		print STDERR "Debug:".$d."\n" if($debug);
		$d=~s/All right\, your contract number is (.*)\. Do you want anything else\?/$1/s;
		$d=~s/>//s;
		$d=~s/^\s+|\s+$//gs;
		one($d);
	}else{
		four("No connection");
	}
}
if($act eq 'get')
{
	if(!$id)
	{
		ten("No Flag ID defined");
	}
	my ($state,$resp,$code)=HTTPRequest("GET","http://$ip:".PORTGET."/${id}.swf");
	print STDERR "Debug:HTTP done\n" if($debug);
	if($state)
	{
		print STDERR "Debug:HTTP succeded\n" if($debug);
		my $r=`./flag2swf $flag`;
		$r=~s/^\s+|\s+$//g;
		if(!length($r)){ten("System call to SWF transformer failed");}
		my $res=undef;
		my $count=0;
		{
			open FF,"$r" or ten("Flash was not generated");
			binmode FF;
			$count=read(FF,$res,1024*1024*20);
			close FF;
		}
		if(!unlink $r)
		{
			if($debug){print STDERR "Debug: $r not unlinked $?:$!\n";}
		}else{
			if($debug){print STDERR "Debug: $r unlinked\n";}
		}
		if(compare($res,$resp))
		{
			one("OK");
		}else{
			if($debug)
			{
				open FF,">$id";
				binmode FF;
				print FF $res;
				close FF;
				open FF,">~$id";
				binmode FF;
				print FF $resp;
				close FF;
			}
			two("Incorrect flag");
		}
	}else{
		if($code == 403 || $code == 404)
		{
			two("Flag not found");
		}else{
			four("No connection");
		}
	}
}
if($act eq 'check')
{
	my ($state,$resp,$code)=HTTPRequest("GET","http://$ip:".PORTGET."/");
	print STDERR "Debug: HTTP done http://$ip:".PORTGET."/\n" if($debug);
	if($state)
	{
		print STDERR "Debug:HTTP succeded\n" if($debug);
		my ($state,$handle)=SocketConnect($ip,PORTACT);
		print STDERR "Debug:Socket done\n" if($debug);
		if($state)
		{
			print STDERR "Debug:Socket succeded\n" if($debug);
			my $d='';
			if(!defined sendReq($handle,'')){ten("Can't start send");}
			$d=longWait($handle);
			if(!$d){three("No Elephant came");}
			print STDERR "Debug:".$d."\n" if($debug);
			if(!defined sendReq($handle,"I want to activate test-drive\r\n")){ten("Can't send");}
			my $d=recvTry($handle);
			if(!$d){three("No Dialog succeded");}
			print STDERR "Debug:".$d."\n" if($debug);
			if($d=~/^OK\, we need your contract number for that/)
			{
				one("OK");
			}else{
				three("No Dialog succeded");
			}
		}else{
			four("No connection");
		}
		four("No connection");
	}else{
		four("No connection");
	}
}
ten("No Command defined");